﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection.Emit;
using System.Reflection;

namespace demo1
{
    class Program
    {
        static void Main(string[] args)
        {
            //创建程序集“DynamicAssembly”
            AssemblyBuilder assemblyBuilder = AppDomain.CurrentDomain.DefineDynamicAssembly(
                new AssemblyName("DynamicAssembly")//
                , AssemblyBuilderAccess.Run //该程序集只用作运行，你还可以创建可保存的程序集
                );

            //创建模块“DynamicModule”
            ModuleBuilder moduleBuilder = assemblyBuilder.DefineDynamicModule("DynamicModule");

            //创建类型“DynamicClass”
            TypeBuilder typeBuilder = moduleBuilder.DefineType("DynamicClass"
                , TypeAttributes.Public | TypeAttributes.Class //相当于 public class DynamicClass
                , null //基类
                , null //接口
                );

            //为类型增加一个方法“Greet”
            MethodBuilder methodBuilder = typeBuilder.DefineMethod("Greet"
                , MethodAttributes.Public
                );

            //获得ILGenerator对象，该对象用来为方法注入IL语言
            ILGenerator g = methodBuilder.GetILGenerator();

            //将字符串"HelloWorld"放到堆栈顶端
            g.Emit(OpCodes.Ldstr, "HelloWorld");
            //调用Console.WriteLine打印堆栈顶端的值
            g.Emit(OpCodes.Call, typeof(Console).GetMethod("WriteLine"
                , BindingFlags.Public | BindingFlags.Static
                , null
                , new Type[] { typeof(string) }
                , null));
            //return
            g.Emit(OpCodes.Ret);

            //创建动态类型
            Type type = typeBuilder.CreateType();
            //实例化类型
            object target = Activator.CreateInstance(type);
            //获得Greet方法的描述
            MethodInfo mi = type.GetMethod("Greet");
            //调用方法
            mi.Invoke(target, null);
        }
    }
}
