﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace demo2
{
    public partial class Form1 : Form
    {
        MyObject myObject;

        public Form1()
        {
            InitializeComponent();

            myObject = new MyObject();
            myObject.Add("Name", "wj");
            myObject.Add("Sex", "male");
            myObject.Add("Age", "31");

            UpdateGui();
        }

        private void UpdateGui()
        {
            UpdatePropGrid();
            myObject.FillListView(listView1);
        }

        private void UpdatePropGrid()
        {
            propertyGrid1.SelectedObject = ObjectWrappeerBuilder.Build(myObject,
                delegate(string name, object value)
                {
                    return true;
                },
                delegate(string name, object value)
                {
                    myObject.Add(name, value.ToString());
                    UpdateGui();
                });
        }

        private void button_AddRow_Click(object sender, EventArgs e)
        {
            string key = "";
            string val = "";
            if(listView1.SelectedItems.Count > 0)
            {
                ListViewItem lvi = listView1.SelectedItems[0];
                key = lvi.Text;
                val = lvi.SubItems[1].Text;
            }
            Form2 dlg = new Form2(key, val);
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                myObject.Add(dlg.Key, dlg.Value);
                UpdateGui();
            }
        }
    }

    /// <summary>
    /// 这个对象模拟了一个业务实体对象，他的属性是用Dictionary保存的因此可以动态增减
    /// </summary>
    class MyObject:IPropertyContainer
    {
        Dictionary<string, string> properties = new Dictionary<string, string>();

        #region IPropertyContainer 成员

        public IEnumerable<string> PropertyNames
        {
            get { return properties.Keys; }
        }

        public object this[string key]
        {
            get
            {
                return properties[key];
            }
            set
            {
                Add(key,value.ToString());
            }
        }

        #endregion

        internal void Add(string k, string v)
        {
            if (properties.ContainsKey(k))
            {
                properties[k] = v;
            }
            else
            {
                properties.Add(k, v);
            }
        }

        internal void FillListView(ListView listView1)
        {
            listView1.Items.Clear();
            foreach (KeyValuePair<string, string> i in properties)
            {
                ListViewItem lvi = listView1.Items.Add(i.Key);
                lvi.SubItems.Add(i.Value);
            }
        }
    }
}