using System.Collections.Generic;
using System;
using System.Reflection.Emit;
using System.Reflection;

namespace demo2
{
    /// <summary>
    /// һԶʵӿ
    /// </summary>
    public interface IPropertyContainer
    {
        /// <summary>
        /// б
        /// </summary>
        IEnumerable<string> PropertyNames { get; }

        /// <summary>
        /// ûֵ
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        object this[string key] { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public static class ObjectWrappeerBuilder
    {
        /// <summary>
        /// öִǰ
        /// </summary>
        /// <param name="name"></param>
        /// <param name="value">ֵ</param>
        /// <returns>trueִãִ</returns>
        public delegate bool PrevSet(string name, object value);

        /// <summary>
        /// öɹ
        /// </summary>
        /// <param name="name"></param>
        /// <param name="value">ֵ</param>
        public delegate void PostSet(string name, object value);

        /// <summary>
        /// ̬
        /// </summary>
        /// <param name="propObj">Դ</param>
        /// <param name="prevSet">ǰö</param>
        /// <param name="postSet">úö</param>
        /// <returns>ض̬</returns>
        public static object Build(IPropertyContainer propObj, PrevSet prevSet, PostSet postSet)
        {
            //һ̬򼯡DynamicAssembly
            AssemblyBuilder assemblyBuilder =
                AppDomain.CurrentDomain.DefineDynamicAssembly(
                new AssemblyName("DynamicAssembly")
                , AssemblyBuilderAccess.Run);

            //Ϊһģ顰DynamicModule
            ModuleBuilder moduleBuilder = assemblyBuilder.DefineDynamicModule("DynamicModule");

            //һ̬͡
            TypeBuilder typeBuilder = moduleBuilder.DefineType(propObj.GetType().Name + "PropertiesWrapper"
                , TypeAttributes.NotPublic | TypeAttributes.Class //͵ԣpublic class
                , typeof(object) //ûΪobjectΪҪû๹캯
                , null);

            //ΪһԱelementIPropertyContainer
            FieldBuilder eleFB = typeBuilder.DefineField("element", propObj.GetType()
                , System.Reflection.FieldAttributes.Private);

            //ΪһԱprevSetPrevSet
            FieldBuilder prevSetFB = typeBuilder.DefineField("prevSet", prevSet.GetType()
                , System.Reflection.FieldAttributes.Private);

            //ΪһԱpostSetPostSet
            FieldBuilder postSetFB = typeBuilder.DefineField("postSet", postSet.GetType()
                , System.Reflection.FieldAttributes.Private);

            //ֵӳ͵property
            foreach (string key in propObj.PropertyNames)
            {
                BuildProperty(propObj, typeBuilder, prevSet, prevSetFB, postSet
                    , postSetFB, eleFB, key, propObj[key]);
            }

            //飬һڸַ亯
            Type[] argTypes = new Type[] { propObj.GetType(), prevSet.GetType(), postSet.GetType() };

            //幹캯Ҫַʽⲿֵ̬
            ConstructorBuilder defCtorBuilder
                = typeBuilder.DefineConstructor(MethodAttributes.Public
                , CallingConventions.Standard
                , argTypes //Ǹն˹캯Ĳб
                );

            //ù캯ILGenerator
            ILGenerator cilg = defCtorBuilder.GetILGenerator();

            //û๹캯
            ConstructorInfo objCtor = Type.GetType("System.Object").GetConstructor(new Type[0]);

            //ILԷɣ
            /*
             * ctor(IPropertyContainer propObj, PrevSet prevSet, PostSet postSet)
             * :base()
             * {
             *  this.element = propObj;
             *  this.prevSet = prevSet;
             *  this.postSet = postSet;
             * }
             * */
            cilg.Emit(OpCodes.Ldarg_0);
            cilg.Emit(OpCodes.Call, objCtor);
            cilg.Emit(OpCodes.Ldarg_0);
            cilg.Emit(OpCodes.Ldarg_1);
            cilg.Emit(OpCodes.Stfld, eleFB);
            cilg.Emit(OpCodes.Ldarg_0);
            cilg.Emit(OpCodes.Ldarg_2);
            cilg.Emit(OpCodes.Stfld, prevSetFB);
            cilg.Emit(OpCodes.Ldarg_0);
            cilg.Emit(OpCodes.Ldarg_3);
            cilg.Emit(OpCodes.Stfld, postSetFB);
            cilg.Emit(OpCodes.Ret);

            //
            Type type = typeBuilder.CreateType();

            //ʵ
            return Activator.CreateInstance(type, new object[] { propObj, prevSet, postSet }, null);
        }

        /// <summary>
        /// һֵԱһproperty
        /// </summary>
        /// <param name="propObj">Դ</param>
        /// <param name="typeBuilder"></param>
        /// <param name="prevSet">ǰ¼</param>
        /// <param name="prevSetFB">ǰ¼Ա</param>
        /// <param name="postSet">ú¼</param>
        /// <param name="postSetFB">ú¼Ա</param>
        /// <param name="eleFB">ԴԱ</param>
        /// <param name="key"></param>
        /// <param name="val">ֵ</param>
        private static void BuildProperty(IPropertyContainer propObj, TypeBuilder typeBuilder
            , PrevSet prevSet, FieldBuilder prevSetFB, PostSet postSet, FieldBuilder postSetFB
            , FieldBuilder eleFB, string key, object val)
        {
            //һproperty
            PropertyBuilder propBuilder = typeBuilder.DefineProperty(key
                , System.Reflection.PropertyAttributes.None, val.GetType(), null);

            //һpropertyget
            MethodBuilder getMethodBuilder = typeBuilder.DefineMethod("get_" + key,
                MethodAttributes.Public,
                val.GetType(), new Type[] { });

            //øúILGenerator
            ILGenerator ilg = getMethodBuilder.GetILGenerator();

            //IPropertyContainerproperty: this[string key]
            PropertyInfo pi = typeof(IPropertyContainer).GetProperty("Item", new Type[] { typeof(string) });

            //ILԷɣ
            /*
             * get
             * {
             *  return element[key];
             * }
             * */
            ilg.Emit(OpCodes.Ldarg_0);
            ilg.Emit(OpCodes.Ldfld, eleFB);
            ilg.Emit(OpCodes.Ldstr, key);
            ilg.EmitCall(OpCodes.Call, pi.GetGetMethod(), null);
            ilg.Emit(OpCodes.Ret);

            //úΪpropertyget
            propBuilder.SetGetMethod(getMethodBuilder);

            //һpropertyset
            MethodBuilder setMethodBuilder = typeBuilder.DefineMethod("set_" + key,
                MethodAttributes.Public,
                null, new Type[] { val.GetType() });

            //øúILGenerator
            ilg = setMethodBuilder.GetILGenerator();

            //ILԷɣ
            /*
             * set
             * {
             *  if(this.prevSet(value))
             *  {
             *      this.element[key] = value;
             *      this.postSet(value);
             *  }
             * }
             * 
             * ر˵һ£һᷢ־һilg.Emit(OpCodes.Ldarg_0);ĵ
             * ʵڽthisָŵջˣΪǾ̬ĳԱĵһʵ
             * thisָ룬ֻҪҪóԱҪȵδ롣Python
             * ĿͲˡ
             */
            System.Reflection.Emit.Label get_out = ilg.DefineLabel();

            ////ǰúжǷ
            ilg.Emit(OpCodes.Ldarg_0);
            ilg.Emit(OpCodes.Ldfld, prevSetFB);
            ilg.Emit(OpCodes.Ldstr, key);
            ilg.Emit(OpCodes.Ldarg_1);
            ilg.Emit(OpCodes.Call, prevSet.GetType().GetMethod("Invoke"));
            ilg.Emit(OpCodes.Brfalse, get_out);//Ϊfalseתget_out

            //ú
            ilg.Emit(OpCodes.Ldarg_0);
            ilg.Emit(OpCodes.Ldfld, eleFB);
            ilg.Emit(OpCodes.Ldstr, key);
            ilg.Emit(OpCodes.Ldarg_1);
            ilg.EmitCall(OpCodes.Callvirt, pi.GetSetMethod(), null);

            //úú
            ilg.Emit(OpCodes.Ldarg_0);
            ilg.Emit(OpCodes.Ldfld, postSetFB);
            ilg.Emit(OpCodes.Ldstr, key);
            ilg.Emit(OpCodes.Ldarg_1);
            ilg.Emit(OpCodes.Call, postSet.GetType().GetMethod("Invoke"));
            ilg.MarkLabel(get_out);
            ilg.Emit(OpCodes.Ret);
            
            //úΪpropertyset
            propBuilder.SetSetMethod(setMethodBuilder);
        }
    }
}